(* SDL.getticks () -- how many hundredths of a second since SDL started? *)
(* event loop: a case statement *)

val screen = SDL.makescreen (300, 100)

fun requireimage s =
      let val s = "testgraphics/" ^ s
      in
          case SDL.Image.load s of
              NONE => (print ("couldn't open " ^ s ^ "\n");
                       raise Fail "end of death")
            | SOME p => p
      end

  structure Font = FontFn (val surf = requireimage "font.png"
                           val charmap =
                           " ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789" ^
                           "`-=[]\\;',./~!@#$%^&*()_+{}|:\"<>?" (* \" *)
                           (* CHECKMARK ESC HEART LCMARK1 LCMARK2 BAR_0 BAR_1 BAR_2 BAR_3-
                              BAR_4 BAR_5 BAR_6 BAR_7 BAR_8 BAR_9 BAR_10 BARSTART LRARROW LLARROW *)
                           val width = 9
                           val height = 16
                           val styles = 6
                           val overlap = 1
                           val dims = 3)

val black = SDL.color (0w0, 0w0, 0w0, 0w0)
fun spew s = (SDL.clearsurface (screen, black);
              Font.draw (screen, 50, 42, s);
              SDL.flip screen)

fun loop () =
    case SDL.pollevent () of
        NONE => (SDL.delay 0; loop ())
      (* quit on escape or Mac quit *)
      | SOME (SDL.E_KeyDown { sym = SDL.SDLK_ESCAPE }) => ()
      | SOME SDL.E_Quit => ()
      (* print keys on press and release *)
      | SOME (SDL.E_KeyDown { sym }) =>
            (spew ("Down: " ^ SDL.sdlktos sym); loop ())
      | SOME (SDL.E_KeyUp { sym }) =>
            (spew ("  Up: " ^ SDL.sdlktos sym); loop ())
      | SOME _ => loop ()


val () =
    let in
      spew "test";
      loop ()
    end
